package Smash::Utils::GFFlite;
use strict;
use warnings;
use Smash::Utils::GFF;

sub new {
	my $class = shift;
	my $fh    = shift;
	if (ref $fh !~ /GLOB/) {
		die "GFFlite needs a GLOB reference!";
	}
	my $this = bless {FH => $fh}, $class;
	$this->{BUFFER} = $this->read_next_line();
	return $this;
}

sub nextFeature {
	my $this = shift;

	return 0 unless $this->{BUFFER};
	my $feature = Smash::Utils::GFF::line2feature($this->{BUFFER});
	$this->{BUFFER} = $this->read_next_line();
	return $feature;

}

sub read_next_line {
	my $this = shift;
	my $fh   = $this->{FH};
	my $line;

	return 0 if eof $fh;

	# get the next non-comment line

	do {
		$line = <$fh>;
	} while ($line =~ /^#/);

	return 0 unless $line;
	return 0 if ($line =~ /^#/);
	chomp($line);
	return $line;
}

1;
